'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _Fynx = require('fynx');

var _Fynx2 = _interopRequireWildcard(_Fynx);

var action = (function (_action) {
  function action(_x, _x2) {
    return _action.apply(this, arguments);
  }

  action.toString = function () {
    return action.toString();
  };

  return action;
})(function (name, cb) {
  if (!action[name]) action[name] = _Fynx2['default'].createAsyncAction(name);

  if (typeof cb === 'function') {
    if (name === 'listen' || name === 'unlisten') throw new Error('Can\'t name your action \'listen\' or \'unlisten\'');

    return action[name].listen(cb);
  } else if (action[name]) return action[name](cb);
});

action.unlisten = function (name, fn) {
  if (action[name]) action[name].unlisten(fn);
};

exports['default'] = action;
module.exports = exports['default'];